/*================================================================================================================================================*/
// *************************************************** THESE ARE THE INFORMATIONS OF THE MAP: *************************************************** //
/*================================================================================================================================================*/
 
// THE OSAKA CONQUEST:
// CREATED BY DANY:
// JULY 2010:

/*================================================================================================================================================*/
// ************************************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *************************************************** //
/*================================================================================================================================================*/

include "mercenaries.xs";
include "ypAsianInclude.xs";
include "ypKOTHInclude.xs";

//main function
void main(void)
{

/*================================================================================================================================================*/
    // TEXT:
    // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.01);
/*================================================================================================================================================*/
// ************************************************ CHOOSES WHICH NATIVES APPEAR ON THE MAP: **************************************************** //
/*================================================================================================================================================*/

	    int subCiv0=-1;
        int subCiv1=-1;
		int subCiv2=-1;
        int subCiv3=-1;
		int subCiv4=-1;
        int subCiv5=-1;
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		

        if (rmAllocateSubCivs(2) == true)
	{
		subCiv0=rmGetCivID("zen");
		rmEchoInfo("subCiv0 is zen "+subCiv0);
		if (subCiv0 >= 0)
		rmSetSubCiv(0, "zen");

		subCiv1=rmGetCivID("jesuit");
		rmEchoInfo("subCiv1 is jesuit "+subCiv1);
		if (subCiv1 >= 0)
		rmSetSubCiv(1, "jesuit");
		
		subCiv2=rmGetCivID("zen");
		rmEchoInfo("subCiv2 is zen "+subCiv2);
		if (subCiv2 >= 0)
		rmSetSubCiv(2, "zen");
		
		subCiv3=rmGetCivID("jesuit");
		rmEchoInfo("subCiv3 is jesuit "+subCiv3);
		if (subCiv3 >= 0)
		rmSetSubCiv(3, "jesuit");
		
		subCiv4=rmGetCivID("zen");
		rmEchoInfo("subCiv4 is zen "+subCiv4);
		if (subCiv4 >= 0)
		rmSetSubCiv(4, "zen");
		
		subCiv5=rmGetCivID("jesuit");
		rmEchoInfo("subCiv5 is jesuit "+subCiv5);
		if (subCiv5 >= 0)
		rmSetSubCiv(5, "jesuit");
	}

/*================================================================================================================================================*/
    // TEXT:
    // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.05);
/*================================================================================================================================================*/
// ********************************************************* SET THE SIZE OF THE MAP: *********************************************************** //
/*================================================================================================================================================*/

	    int playerTiles=25000;

	    int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	    rmEchoInfo("Map size="+size+"m x "+size+"m");
	    rmSetMapSize(632, 632); // THE NUMBER 632 IS REPLACING THE WORD - "size" -: 
		
/*================================================================================================================================================*/
    // TEXT:
    // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.10);
/*================================================================================================================================================*/
// ********************************************************* DEFINE THE MAP PARAMETERS: ********************************************************* //		
/*================================================================================================================================================*/

		// SET SEA LEVEL:
		rmSetSeaLevel(1.0);          
	    
		// SET SEA TYPE:
		rmSetSeaType("Coastal Japan");
        
		// ENABLE LOCAL WATER:
		rmEnableLocalWater(false);
	    
		// SET BASE TERRAIN MIX:
		rmSetBaseTerrainMix("coastal_japan_b");
	
	    // SET MAP TYPE:
		rmSetMapType("Japan");
	    rmSetMapType("grass");
	    rmSetMapType("water");
	    
		// SET LIGHTING:
		rmSetLightingSet("Honshu");

	    // MAP INITIALIZATION:
	    rmTerrainInitialize("water");
	
	    // CHOOSE MERCS:
		chooseMercs();
	
/*================================================================================================================================================*/
    // TEXT:
    // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.15);
/*================================================================================================================================================*/
// ****************************************************** MISC VARIABLES FOR USE LATER: ********************************************************* //
/*================================================================================================================================================*/

	    int numTries = -1;
	
/*================================================================================================================================================*/
    // TEXT:
    // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.16);
/*================================================================================================================================================*/
// ************************************** DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ******************************************** //
/*================================================================================================================================================*/	

	    // DEFINE THE CLASS PLAYER:
		int classPlayer=rmDefineClass("player");

/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================================================*/
// ******************************************************** DEFINE THE CONSTRAINTS: ************************************************************* //
// **************************************** THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ****************************************** //
/*================================================================================================================================================*/
    
    // DEFINE THE MAP EDGE CONSTRAINTS:
    int playerEdgeConstraint=rmCreatePieConstraint("player edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.475), rmDegreesToRadians(0), rmDegreesToRadians(360));
    //int forestEdgeConstraint=rmCreatePieConstraint("forest edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.480), rmDegreesToRadians(0), rmDegreesToRadians(360));
   	int nativesEdgeConstraint=rmCreatePieConstraint("natives edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.475), rmDegreesToRadians(0), rmDegreesToRadians(360));
  
    // DEFINE THE PLAYER CONSTRAINTS:
	int playerFarConstraint=rmCreateClassDistanceConstraint("players vs players", classPlayer, 65.0);
    int playerConstraint=rmCreateClassDistanceConstraint("stuff vs players", classPlayer, 20.0);
	int playerMediumConstraint=rmCreateClassDistanceConstraint("medium stuff vs players", classPlayer, 30.0);
	int playerCloseConstraint=rmCreateClassDistanceConstraint("close stuff vs players", classPlayer, 15.0);
	int playerVeryCloseConstraint=rmCreateClassDistanceConstraint("very close stuff vs players", classPlayer, 10.0);
	int playerClosestConstraint=rmCreateClassDistanceConstraint("closest stuff vs players", classPlayer, 5.0);
	
    // DEFINE THE CARDINAL DIRECTIONS CONSTRAINTS (HANDY!)
    int Northward=rmCreatePieConstraint("northMapConstraint", 0.50, 0.50, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
    int Southward=rmCreatePieConstraint("southMapConstraint", 0.50, 0.50, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
    int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.50, 0.50, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
    int Westward=rmCreatePieConstraint("westMapConstraint", 0.50, 0.50, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));
    int Oneward=rmCreatePieConstraint("oneMapConstraint", 0.50, 0.50, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(270), rmDegreesToRadians(90));
    int Twoward=rmCreatePieConstraint("twoMapConstraint", 0.50, 0.50, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(90), rmDegreesToRadians(270));
	int Redward=rmCreatePieConstraint("redMapConstraint", 0.50, 0.50, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(360), rmDegreesToRadians(180));
    int Blueward=rmCreatePieConstraint("blueMapConstraint", 0.50, 0.50, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(180), rmDegreesToRadians(360));
    
	
	// DEFINE THE DECORATION AVOIDANCE:
    int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);
	int avoidClosestAll=rmCreateTypeDistanceConstraint("closest stuff vs all", "all", 4.0);
	int avoidFarAll=rmCreateTypeDistanceConstraint("far avoid all", "all", 15.0);
	
	// DEFINE THE CONSTRAINTS TO AVOID WATER:
	int avoidWater2 = rmCreateTerrainDistanceConstraint("stuff vs water 2", "Land", false, 2.0);   //I added this one so I could experiment with it.
	int avoidWater4 = rmCreateTerrainDistanceConstraint("stuff vs water 4", "Land", false, 4.0); 
	int avoidWater5 = rmCreateTerrainDistanceConstraint("stuff vs water 5", "Land", false, 5.0);
	int avoidWater6 = rmCreateTerrainDistanceConstraint("stuff vs water 6", "Land", false, 6.0);
	int avoidWater8 = rmCreateTerrainDistanceConstraint("stuff vs water 8", "Land", false, 8.0);
	int avoidWater10 = rmCreateTerrainDistanceConstraint("stuff vs water 10", "Land", false, 10.0);
	int avoidWater12 = rmCreateTerrainDistanceConstraint("stuff vs water 12", "Land", false, 12.0);
	int avoidWater15 = rmCreateTerrainDistanceConstraint("stuff vs water 15", "Land", false, 15.0);
	int avoidWater20 = rmCreateTerrainDistanceConstraint("stuff vs water 20", "Land", false, 20.0);
	int avoidWater25 = rmCreateTerrainDistanceConstraint("stuff vs water 25", "Land", false, 25.0);
	int avoidWater30 = rmCreateTerrainDistanceConstraint("stuff vs water 30", "Land", false, 30.0);
	int avoidWater45 = rmCreateTerrainDistanceConstraint("stuff vs water 45", "Land", false, 45.0);
	int avoidWater60 = rmCreateTerrainDistanceConstraint("stuff vs water 60", "Land", false, 60.0);
	
	// CIRCLE CONSTRAINT:
	int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.485), rmDegreesToRadians(0), rmDegreesToRadians(360));

/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================================================*/
// ***************************************************** DEFINE AND PLACE THE BIG ISLAND: ******************************************************* //
/*================================================================================================================================================*/
  
	    // DEFINE THE CLASS ISLAND:
		int classIsland=rmDefineClass("island");
		
		// DEFINE THE CLASS ISLAND CONSTRAINTS:
		int islandConstraint=rmCreateClassDistanceConstraint("stay away from main island", classIsland, 12.0);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
		
		int bigIslandID=rmCreateArea("big lone island");
	    rmSetAreaSize(bigIslandID, 0.0610, 0.0610);
	    rmSetAreaCoherence(bigIslandID, 1.0);
	    rmSetAreaBaseHeight(bigIslandID, 2.0);
	    rmSetAreaSmoothDistance(bigIslandID, 20);
	    rmSetAreaMix(bigIslandID, "coastal_japan_b");
	    rmAddAreaToClass(bigIslandID, classIsland);
	    rmAddAreaConstraint(bigIslandID, islandConstraint);
	    rmSetAreaObeyWorldCircleConstraint(bigIslandID, false);
	    
		rmSetAreaElevationType(bigIslandID, cElevTurbulence);
	    rmSetAreaElevationVariation(bigIslandID, 2.5);
	    rmSetAreaElevationMinFrequency(bigIslandID, 0.09);
	    rmSetAreaElevationOctaves(bigIslandID, 3);
	    rmSetAreaElevationPersistence(bigIslandID, 0.2);
	    rmSetAreaElevationNoiseBias(bigIslandID, 1);

        rmAddAreaInfluenceSegment(bigIslandID, 0.400, 0.100, 0.350, 0.300); // no 01 to 02:
		rmAddAreaInfluenceSegment(bigIslandID, 0.350, 0.300, 0.300, 0.350); // no 02 to 03:
		rmAddAreaInfluenceSegment(bigIslandID, 0.300, 0.350, 0.100, 0.400); // no 03 to 04:
		rmAddAreaInfluenceSegment(bigIslandID, 0.100, 0.400, 0.100, 0.600); // no 04 to 05:
  
        rmAddAreaInfluenceSegment(bigIslandID, 0.100, 0.600, 0.300, 0.650); // no 05 to 06:
		rmAddAreaInfluenceSegment(bigIslandID, 0.300, 0.650, 0.350, 0.700); // no 06 to 07:
		rmAddAreaInfluenceSegment(bigIslandID, 0.350, 0.700, 0.400, 0.900); // no 07 to 08:
		rmAddAreaInfluenceSegment(bigIslandID, 0.400, 0.900, 0.600, 0.900); // no 08 to 09:
		
		rmAddAreaInfluenceSegment(bigIslandID, 0.600, 0.900, 0.650, 0.700); // no 09 to 10:
		rmAddAreaInfluenceSegment(bigIslandID, 0.650, 0.700, 0.700, 0.650); // no 10 to 11:
		rmAddAreaInfluenceSegment(bigIslandID, 0.700, 0.650, 0.900, 0.600); // no 11 to 12:
		rmAddAreaInfluenceSegment(bigIslandID, 0.900, 0.600, 0.900, 0.400); // no 12 to 13:
		
		rmAddAreaInfluenceSegment(bigIslandID, 0.900, 0.400, 0.700, 0.350); // no 13 to 14:
		rmAddAreaInfluenceSegment(bigIslandID, 0.700, 0.350, 0.650, 0.300); // no 14 to 15:
		rmAddAreaInfluenceSegment(bigIslandID, 0.650, 0.300, 0.600, 0.100); // no 15 to 16:
		rmAddAreaInfluenceSegment(bigIslandID, 0.600, 0.100, 0.400, 0.100); // no 16 to 01:

	    rmSetAreaWarnFailure(bigIslandID, false);
	    rmSetAreaLocation(bigIslandID, .5, .5);		//Put the big island in exact middle of map.
	    rmBuildArea(bigIslandID);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/

        // ADD BIG ISLAND CONSTRAINTS:
        int bigIslandConstraint=rmCreateAreaConstraint("big lone island", bigIslandID);		
	
/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================================================*/
// **************************************************** DEFINE AND PLACE THE SMALL ISLANDS: ***************************************************** //
/*================================================================================================================================================*/
  
	    // DEFINE THE CLASS SMALL ISLAND:
		int classSmallIsland=rmDefineClass("smallIsland");
		
		// DEFINE THE CLASS SMALL ISLAND CONSTRAINTS:
		int smallIslandConstraint=rmCreateClassDistanceConstraint("stay away from small island", classSmallIsland, 12.0);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
		
		int smallIslandID=rmCreateArea("small island 1");
	    rmSetAreaSize(smallIslandID, 0.015, 0.015);
	    rmSetAreaCoherence(smallIslandID, 1.0);
	    rmSetAreaBaseHeight(smallIslandID, 2.0);
	    rmSetAreaSmoothDistance(smallIslandID, 20);
	    rmSetAreaMix(smallIslandID, "coastal_japan_b");
	    rmAddAreaToClass(smallIslandID, classSmallIsland);
	    rmAddAreaConstraint(smallIslandID, smallIslandConstraint);
	    rmSetAreaObeyWorldCircleConstraint(smallIslandID, false);
	    
		rmSetAreaElevationType(smallIslandID, cElevTurbulence);
	    rmSetAreaElevationVariation(smallIslandID, 4.0);
	    rmSetAreaElevationMinFrequency(smallIslandID, 0.09);
	    rmSetAreaElevationOctaves(smallIslandID, 3);
	    rmSetAreaElevationPersistence(smallIslandID, 0.2);
	    rmSetAreaElevationNoiseBias(smallIslandID, 1);

	    rmSetAreaWarnFailure(smallIslandID, false);
	    rmSetAreaLocation(smallIslandID, .225, .225);		
	    rmBuildArea(smallIslandID);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
        
		int smallIsland2ID=rmCreateArea("small island 2");
	    rmSetAreaSize(smallIsland2ID, 0.015, 0.015);
	    rmSetAreaCoherence(smallIsland2ID, 1.0);
	    rmSetAreaBaseHeight(smallIsland2ID, 2.0);
	    rmSetAreaSmoothDistance(smallIsland2ID, 20);
	    rmSetAreaMix(smallIsland2ID, "coastal_japan_b");
	    rmAddAreaToClass(smallIsland2ID, classSmallIsland);
	    rmAddAreaConstraint(smallIsland2ID, smallIslandConstraint);
	    rmSetAreaObeyWorldCircleConstraint(smallIsland2ID, false);
	    
		rmSetAreaElevationType(smallIsland2ID, cElevTurbulence);
	    rmSetAreaElevationVariation(smallIsland2ID, 4.0);
	    rmSetAreaElevationMinFrequency(smallIsland2ID, 0.09);
	    rmSetAreaElevationOctaves(smallIsland2ID, 3);
	    rmSetAreaElevationPersistence(smallIsland2ID, 0.2);
	    rmSetAreaElevationNoiseBias(smallIsland2ID, 1);

	    rmSetAreaWarnFailure(smallIsland2ID, false);
	    rmSetAreaLocation(smallIsland2ID, .775, .775);		
	    rmBuildArea(smallIsland2ID);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/

        int smallIsland3ID=rmCreateArea("small island 3");
	    rmSetAreaSize(smallIsland3ID, 0.015, 0.015);
	    rmSetAreaCoherence(smallIsland3ID, 1.0);
	    rmSetAreaBaseHeight(smallIsland3ID, 2.0);
	    rmSetAreaSmoothDistance(smallIsland3ID, 20);
	    rmSetAreaMix(smallIsland3ID, "coastal_japan_b");
	    rmAddAreaToClass(smallIsland3ID, classSmallIsland);
	    rmAddAreaConstraint(smallIsland3ID, smallIslandConstraint);
	    rmSetAreaObeyWorldCircleConstraint(smallIsland3ID, false);
	    
		rmSetAreaElevationType(smallIsland3ID, cElevTurbulence);
	    rmSetAreaElevationVariation(smallIsland3ID, 4.0);
	    rmSetAreaElevationMinFrequency(smallIsland3ID, 0.09);
	    rmSetAreaElevationOctaves(smallIsland3ID, 3);
	    rmSetAreaElevationPersistence(smallIsland3ID, 0.2);
	    rmSetAreaElevationNoiseBias(smallIsland3ID, 1);

	    rmSetAreaWarnFailure(smallIsland3ID, false);
	    rmSetAreaLocation(smallIsland3ID, .225, .775);		
	    rmBuildArea(smallIsland3ID);

/*------------------------------------------------------------------------------------------------------------------------------------------------*/

        int smallIsland4ID=rmCreateArea("small island 4");
	    rmSetAreaSize(smallIsland4ID, 0.015, 0.015);
	    rmSetAreaCoherence(smallIsland4ID, 1.0);
	    rmSetAreaBaseHeight(smallIsland4ID, 2.0);
	    rmSetAreaSmoothDistance(smallIsland4ID, 20);
	    rmSetAreaMix(smallIsland4ID, "coastal_japan_b");
	    rmAddAreaToClass(smallIsland4ID, classSmallIsland);
	    rmAddAreaConstraint(smallIsland4ID, smallIslandConstraint);
	    rmSetAreaObeyWorldCircleConstraint(smallIsland4ID, false);
	    
		rmSetAreaElevationType(smallIsland4ID, cElevTurbulence);
	    rmSetAreaElevationVariation(smallIsland4ID, 4.0);
	    rmSetAreaElevationMinFrequency(smallIsland4ID, 0.09);
	    rmSetAreaElevationOctaves(smallIsland4ID, 3);
	    rmSetAreaElevationPersistence(smallIsland4ID, 0.2);
	    rmSetAreaElevationNoiseBias(smallIsland4ID, 1);

	    rmSetAreaWarnFailure(smallIsland4ID, false);
	    rmSetAreaLocation(smallIsland4ID, .775, .225);		
	    rmBuildArea(smallIsland4ID);

/*------------------------------------------------------------------------------------------------------------------------------------------------*/

        // ADD SMALL 4 SMALL ISLAND CONSTRAINTS:
        int smallIsland1Constraint=rmCreateAreaConstraint("small island 1", smallIslandID);
        int smallIsland2Constraint=rmCreateAreaConstraint("small island 2", smallIsland2ID);	
        int smallIsland3Constraint=rmCreateAreaConstraint("small island 3", smallIsland3ID);	
        int smallIsland4Constraint=rmCreateAreaConstraint("small island 4", smallIsland4ID);			

/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================================================*/
// **************************************************** SET UP PLAYER STARTING LOCATIONS: ******************************************************* //
/*================================================================================================================================================*/

        float teamSide = rmRandFloat(0, 1);

/*------------------------------------------------------------------------------------------------------------------------------------------------*/
		
        if (teamSide > .5) 
	{
        rmSetPlacementTeam(0);
        rmPlacePlayersLine(0.200, 0.500, 0.500, 0.800, 0.0, 0.0);

        rmSetPlacementTeam(1);
        rmPlacePlayersLine(0.800, 0.500, 0.500, 0.200, 0.0, 0.0);
    }
    
        else 
	{
        rmSetPlacementTeam(1);
        rmPlacePlayersLine(0.200, 0.500, 0.500, 0.800, 0.0, 0.0);

        rmSetPlacementTeam(0);
        rmPlacePlayersLine(0.800, 0.500, 0.500, 0.200, 0.0, 0.0);
    }

/*================================================================================================================================================*/
    // TEXT:
    // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.40);
/*================================================================================================================================================*/
// ****************************************************** SET UP VALLEYS FOR EACH PLAYER: ******************************************************* //
/*================================================================================================================================================*/
 
        int i = 0;
		int id = 0;
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
        
		float playerFraction=rmAreaTilesToFraction(1000);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
  
        for(i=1; < cNumberPlayers)
	{
        // Create the area.
        id=rmCreateArea("Player"+i);

        // Assign to the player.
        rmSetPlayerArea(i, id);

        // SET AREA SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
        
		// ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
        
		// ADD AREA CONSTRAINT:
		//rmAddAreaConstraint(id, playerConstraint); 
        //rmAddAreaConstraint(id, playerEdgeConstraint);
        
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
		
		// SET AREA COHERENCE:
		rmSetAreaCoherence(id, 1.0);
        
		// SET AREA MIX:
		//rmSetAreaMix(id, "bayou_grass");
		//rmSetAreaMix(id, "rockies_snow");
		//rmSetAreaMix(id, "rockies_grass");
		
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
        
		// ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
        
		// BUILD AREA ID:
		rmBuildArea(id);
    }
	
/*================================================================================================================================================*/
    // TEXT:
    // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
    rmSetStatusText("",0.45);
/*================================================================================================================================================*/
// ********************************** DEFINE THE STARTING UNITS AND THE STARTING TCID AND STARTING RESOURCES: *********************************** //
/*================================================================================================================================================*/
	
	    // DEFINE THE CLASS STARTING UNITS:
        int classStartingUnit=rmDefineClass("startingUnit");
		
		// DEFINE THE CLASS STARTING UNITS CONSTRAINTS:
		int avoidStartingUnits=rmCreateClassDistanceConstraint("stuff vs starting units", rmClassID("startingUnit"), 25.0);
        int avoidCloseStartingUnits=rmCreateClassDistanceConstraint("close stuff vs starting units", rmClassID("startingUnit"), 10.0);
        int avoidFarStartingUnits=rmCreateClassDistanceConstraint("far stuff vs starting units", rmClassID("startingUnit"), 65.0);
		int avoidVerycloseStartingUnits=rmCreateClassDistanceConstraint("very close stuff vs starting units", rmClassID("startingUnit"), 5.0);
		int avoidMediumStartingUnits=rmCreateClassDistanceConstraint("medium stuff vs starting units", rmClassID("startingUnit"), 45.0);
		
		int avoidResources=rmCreateTypeDistanceConstraint("stuff vs all", "all", 1.0);

/*------------------------------------------------------------------------------------------------------------------------------------------------*/		

	    // DEFINE THE STARTING TCID:
		int startingTCID= rmCreateObjectDef("startingTC");
		rmSetObjectDefMinDistance(startingTCID, 0);
	    rmSetObjectDefMaxDistance(startingTCID, 0);
		rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));
		
	    if ( rmGetNomadStart())
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	}
	    else
	{
		//rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
		rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
	}
	
/*------------------------------------------------------------------------------------------------------------------------------------------------*/
		
		// DEFINE THE STARTING UNITS:
		int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
		rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
        rmSetObjectDefMinDistance(startingUnits, 5.0);
        rmSetObjectDefMaxDistance(startingUnits, 6.0);
	    
		//rmAddObjectDefConstraint(startingUnits, avoidCloseStartingUnits);
		rmAddObjectDefConstraint(startingUnits, avoidResources);
	
/*------------------------------------------------------------------------------------------------------------------------------------------------*/	

	    // DEFINE THE START BERRY BUSH CONSTRAINTS:
		int avoidStartBerryBush=rmCreateTypeDistanceConstraint("start berries vs start berries", "AbstractFruit", 5.0);
		
		// DEFINE THE START BERRYBUSH:
		int StartBerryBushID=rmCreateObjectDef("starting berry bush");
	    rmAddObjectDefItem(StartBerryBushID, "BerryBush", 1, 0.0);
		rmAddObjectDefToClass(StartBerryBushID, rmClassID("startingUnit"));
	    rmSetObjectDefMinDistance(StartBerryBushID, 8.0);
	    rmSetObjectDefMaxDistance(StartBerryBushID, 10.0);
	    
		rmAddObjectDefConstraint(StartBerryBushID, avoidStartBerryBush);
		rmAddObjectDefConstraint(StartBerryBushID, avoidResources);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
		
		// DEFINE THE START FOOD CONSTRAINTS:
		int avoidStartFood=rmCreateTypeDistanceConstraint("food vs food", "Huntable", 5.0);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
		
		int whichSupplies=rmRandInt(1,2);
	
	    if ( whichSupplies == 1)
	{	
		int StartHuntableID=rmCreateObjectDef("starting Huntable");
	    rmAddObjectDefItem(StartHuntableID, "ypSerow", 1, 0.0);
		rmAddObjectDefToClass(StartHuntableID, rmClassID("startingUnit"));
	    rmSetObjectDefMinDistance(StartHuntableID, 12);
	    rmSetObjectDefMaxDistance(StartHuntableID, 14);
		rmSetObjectDefCreateHerd(StartHuntableID, true);
	    
		rmAddObjectDefConstraint(StartHuntableID, avoidResources);
		rmAddObjectDefConstraint(StartHuntableID, avoidStartFood);
	}	
        else
    {
        int StartHuntable2ID=rmCreateObjectDef("starting Huntable 2");
	    rmAddObjectDefItem(StartHuntable2ID, "ypSerow", 1, 0.0);
		rmAddObjectDefToClass(StartHuntable2ID, rmClassID("startingUnit"));
	    rmSetObjectDefMinDistance(StartHuntable2ID, 12);
	    rmSetObjectDefMaxDistance(StartHuntable2ID, 14);
		rmSetObjectDefCreateHerd(StartHuntable2ID, true);
	    
		rmAddObjectDefConstraint(StartHuntable2ID, avoidResources);	
		rmAddObjectDefConstraint(StartHuntable2ID, avoidStartFood);	
	}
	
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
        
        // DEFINE THE PLAYER SILVER CONSTRAINTS:
		int avoidPlayerSilver=rmCreateTypeDistanceConstraint("silver vs silver", "AbstractMine", 25.0);
		int avoidClosePlayerSilver=rmCreateTypeDistanceConstraint("close silver vs silver", "AbstractMine", 20.0);
		
		// DEFINE THE PLAYER SILVER:
		int playerSilverID = rmCreateObjectDef("player silver");
		int whichPlayerMines=rmRandInt(1,3);
		
		if ( whichPlayerMines == 1)
	{	
	    rmAddObjectDefItem(playerSilverID, "mine", 1, 0);
	}	
	    else if ( whichPlayerMines == 2)
	{	
	    rmAddObjectDefItem(playerSilverID, "mineGold", 1, 0);
	}	
	    else
	{	
		rmAddObjectDefItem(playerSilverID, "mineCopper", 1, 0);
	}	
		
		rmAddObjectDefToClass(playerSilverID, rmClassID("startingUnit"));
	    rmSetObjectDefMinDistance(playerSilverID, 20.0);
	    rmSetObjectDefMaxDistance(playerSilverID, 22.0);
	    
        rmAddObjectDefConstraint(playerSilverID, avoidResources);
		rmAddObjectDefConstraint(playerSilverID, avoidPlayerSilver);

/*------------------------------------------------------------------------------------------------------------------------------------------------*/
        
		// DEFINE THE CLASS PLAYER NUGGETS:
		int classPlayerNuggets=rmDefineClass("playerNuggets");
		
		// DEFINE THE CLASS PLAYER NUGGETS CONSTRAINTS:
		int nuggetPlayerConstraint=rmCreateClassDistanceConstraint("stuff avoids playerNuggets", rmClassID("playerNuggets"), 30.0);
		int nuggetClosePlayerConstraint=rmCreateClassDistanceConstraint("close stuff avoids playerNuggets", rmClassID("playerNuggets"), 15.0);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/

	    // DEFINE THE PLAYER NUGGET: 
	    int playerNuggetID=rmCreateObjectDef("player nugget");
	    rmAddObjectDefItem(playerNuggetID, "Nugget", 1, 0.0);
	    rmAddObjectDefToClass(playerNuggetID, rmClassID("playerNuggets"));
        rmSetObjectDefMinDistance(playerNuggetID, 22.0);
        rmSetObjectDefMaxDistance(playerNuggetID, 24.0);
	    
	    rmAddObjectDefConstraint(playerNuggetID, nuggetPlayerConstraint);
		rmAddObjectDefConstraint(playerNuggetID, avoidClosePlayerSilver);
		rmAddObjectDefConstraint(playerNuggetID, avoidResources);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/

        // DEFINE THE START AREA TREE CONSTRAINTS:
		int avoidStartTrees=rmCreateTypeDistanceConstraint("start area trees vs trees", "Tree", 5.0);
		
		// DEFINE THE START AREA TREES:
	    int StartAreaTreeID=rmCreateObjectDef("starting trees");
	    //rmAddObjectDefItem(StartAreaTreeID, "ypTreeBorneo", rmRandInt(5,7), 5.0);
		rmAddObjectDefItem(StartAreaTreeID, "ypTreeJapaneseMaple", 1, 0.0);
	    rmSetObjectDefMinDistance(StartAreaTreeID, 16);
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 18);
	    //rmAddObjectDefConstraint(StartAreaTreeID, avoidCloseStartingUnits);
		//rmAddObjectDefConstraint(StartAreaTreeID, nuggetClosePlayerConstraint);
		rmAddObjectDefConstraint(StartAreaTreeID, avoidStartTrees);
		rmAddObjectDefConstraint(StartAreaTreeID, avoidResources);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/

        // FLAG CONSTRAINTS FOR HC SPAWN POINT:
        int flagEdgeConstraint = rmCreatePieConstraint("flags away from edge of map", 0.5, 0.5, 0, rmGetMapXSize()-10, 0, 0, 0);
		//int flagEdgeConstraint = rmCreatePieConstraint("flags stay near edge of map", 0.5, 0.5, rmGetMapXSize()-20, rmGetMapXSize()-10, 0, 0, 0);
        //int flagEdgeConstraint = rmCreatePieConstraint("flags away from edge of map", 0.5, 0.5, rmGetMapXSize()-200, rmGetMapXSize()-100, 0, 0, 0);
        //int flagEdgeConstraint=rmCreatePieConstraint("flag edge of map", 0.5, 0.5, 0, rmZFractionToMeters(0.20), rmDegreesToRadians(0), rmDegreesToRadians(360));
  
		
	    int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 15.0);
	    int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 15); 
 	
/*------------------------------------------------------------------------------------------------------------------------------------------------*/	
	
	    // DEFINE THE VARIABLE FOR THE WATER SPAWN POINT:
		int waterSpawnPointID = 0;		

/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================================================*/
// ********************************** PLACE THE STARTING UNITS AND THE STARTING TCID AND STARTING RESOURCES: ************************************ //
/*================================================================================================================================================*/
	    
		// CLEAR OUT CONSTRAINTS FOR GOOD MEASURE:
        rmClearClosestPointConstraints(); 

/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
		
		for(i=1; <cNumberPlayers)
	{
	
		// PLACE THE STARTING TCID:
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		vector TCLoc = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingTCID, i));				
		
		// PLACE THE STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	
		// PLACE THE START BERRYBUSH:
		rmPlaceObjectDefAtLoc(StartBerryBushID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartBerryBushID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartBerryBushID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartBerryBushID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartBerryBushID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		if ( whichSupplies == 1)
	{	
		// PLACE START RESOURCES:
		rmPlaceObjectDefAtLoc(StartHuntableID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartHuntableID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartHuntableID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartHuntableID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartHuntableID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	}
        else
    {		
		// PLACE THE PLAYER CRATE:
		rmPlaceObjectDefAtLoc(StartHuntable2ID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartHuntable2ID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartHuntable2ID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartHuntable2ID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartHuntable2ID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	}	
		
		// PLACE THE PLAYER SILVER:
		rmPlaceObjectDefAtLoc(playerSilverID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerSilverID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
/*		
		// PLACE THE PILGRIMS:
        int pilgrimGroupType = rmRandInt(1,2);
        int pilgrimGroup = 0;
        pilgrimGroup = rmCreateGrouping("Pilgrim Group "+i, "Plymouth_PilgrimGroup "+pilgrimGroupType);
        rmSetGroupingMinDistance(pilgrimGroup, 14.0);
        rmSetGroupingMaxDistance(pilgrimGroup, 20.0);
        rmAddGroupingToClass(pilgrimGroup, rmClassID("startingUnit"));
        rmAddGroupingConstraint(pilgrimGroup, avoidCloseStartingUnits);
        rmPlaceGroupingAtLoc(pilgrimGroup, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
*/		
		// PLACE THE PLAYER NUGGETS:
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	
		// PLACE THE START AREA TREE:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	
/*------------------------------------------------------------------------------------------------------------------------------------------------*/

		// DEFINE THE VECTOR CLOSEST POINT:
		//vector closestPoint=rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingUnits, i));
		
		// JAPANESE:
		if(ypIsAsian(i) && rmGetNomadStart() == false)
        rmPlaceObjectDefAtLoc(ypMonasteryBuilder(i), i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
        
		
		// PLACE THE WATER SPAWN POINTS FOR THE PLAYERS:
		waterSpawnPointID=rmCreateObjectDef("colony ship "+i);
		rmAddObjectDefItem(waterSpawnPointID, "HomeCityWaterSpawnFlag", 1, 0.0);
		
		rmAddClosestPointConstraint(flagVsFlag);
		rmAddClosestPointConstraint(flagLand); 
        rmAddClosestPointConstraint(flagEdgeConstraint); 
		
		vector closestPoint = rmFindClosestPointVector(TCLoc, rmXFractionToMeters(1.0));
		rmPlaceObjectDefAtLoc(waterSpawnPointID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
		
		int catamaranID=rmCreateObjectDef("Catamaran"+i);
        rmAddObjectDefItem(catamaranID, "ypMarathanCatamaran", 1, 0.0);
        rmPlaceObjectDefAtLoc(catamaranID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
          //rmPlaceObjectDefAtLoc(catamaranID(i), i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
   		
		// CLEAR CLOSEST POINT FOR NEXT ITERATION:
        rmClearClosestPointConstraints();		

	}

/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================================================*/
// ************************************* DEFINE AND PLACE THE NATIVE VILLAGES AND SECRETS OF THE NEW WORLD: ************************************* //
/*================================================================================================================================================*/

    // DEFINE THE CLASS NATIVES:
    int classNatives=rmDefineClass("natives");

    // DEFINE THE CLASS NATIVES CONSTRAINTS:
	int nativesSuperFarConstraint=rmCreateClassDistanceConstraint("super far natives vs natives", rmClassID("natives"), 85.0);	
	int nativesVeryFarConstraint=rmCreateClassDistanceConstraint("very far natives vs natives", rmClassID("natives"), 75.0);	
	int nativesFarConstraint=rmCreateClassDistanceConstraint("far natives vs natives", rmClassID("natives"), 65.0);
    int nativesMediumConstraint=rmCreateClassDistanceConstraint("medium stuff vs natives", rmClassID("natives"), 45.0);		
    int nativesConstraint=rmCreateClassDistanceConstraint("stuff vs natives", rmClassID("natives"), 25.0);			
	int nativesCloseConstraint=rmCreateClassDistanceConstraint("close stuff vs natives", rmClassID("natives"), 15.0);
    int nativesVeryCloseConstraint=rmCreateClassDistanceConstraint("very close stuff vs natives", rmClassID("natives"), 10.0);
	int nativesClosestConstraint=rmCreateClassDistanceConstraint("closest stuff vs natives", rmClassID("natives"), 5.0);
    
/*------------------------------------------------------------------------------------------------------------------------------------------------*/			
   
	        if (subCiv0 == rmGetCivID("zen"))
	    {  
		    int nativesVillage1ID = -1;
		    int nativesVillageType = rmRandInt(1,3);
			nativesVillage1ID = rmCreateGrouping("natives village 1", "native zen temple cj 0"+nativesVillageType);
			rmSetGroupingMinDistance(nativesVillage1ID, 0.0);
			rmSetGroupingMaxDistance(nativesVillage1ID, 0.0);
			rmAddGroupingToClass(nativesVillage1ID, rmClassID("natives"));
	
			if (cNumberNonGaiaPlayers <=2)		   
		    rmPlaceGroupingAtLoc(nativesVillage1ID, 0, 0.225, 0.225);
			else
			rmPlaceGroupingAtLoc(nativesVillage1ID, 0, 0.225, 0.225);
	    }
	
/*------------------------------------------------------------------------------------------------------------------------------------------------*/	

	        if (subCiv1 == rmGetCivID("jesuit"))
	    {
	        int nativesVillage2ID = -1;
	        nativesVillageType = rmRandInt(1,3);
	        nativesVillage2ID = rmCreateGrouping("natives village 2", "native jesuit mission cj 0"+nativesVillageType);
	        rmSetGroupingMinDistance(nativesVillage2ID, 0.0);
	        rmSetGroupingMaxDistance(nativesVillage2ID, 0.0);
            rmAddGroupingToClass(nativesVillage2ID, rmClassID("natives"));
	
			if (cNumberNonGaiaPlayers <=2)		   
		    rmPlaceGroupingAtLoc(nativesVillage2ID, 0, 0.775, 0.775);
			else
			rmPlaceGroupingAtLoc(nativesVillage2ID, 0, 0.775, 0.775);
	    }
	
/*------------------------------------------------------------------------------------------------------------------------------------------------*/	
            
			if (subCiv2 == rmGetCivID("zen"))
	    {
	        int nativesVillage3ID = -1;
	        nativesVillageType = rmRandInt(1,3);
	        nativesVillage3ID = rmCreateGrouping("natives village 3", "native zen temple cj 0"+nativesVillageType);
	        rmSetGroupingMinDistance(nativesVillage3ID, 0.0);
	        rmSetGroupingMaxDistance(nativesVillage3ID, 0.0);
            rmAddGroupingToClass(nativesVillage3ID, rmClassID("natives"));

			if (cNumberNonGaiaPlayers <=2)		   
		    rmPlaceGroupingAtLoc(nativesVillage3ID, 0, 0.225, 0.775);
			else
			rmPlaceGroupingAtLoc(nativesVillage3ID, 0, 0.225, 0.775);
	    }
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/
            
			if (subCiv3 == rmGetCivID("jesuit"))
	    {
	        int nativesVillage4ID = -1;
	        nativesVillageType = rmRandInt(1,3);
	        nativesVillage4ID = rmCreateGrouping("natives village 4", "native jesuit mission cj 0"+nativesVillageType);
	        rmSetGroupingMinDistance(nativesVillage4ID, 0.0);
	        rmSetGroupingMaxDistance(nativesVillage4ID, 0.0);
            rmAddGroupingToClass(nativesVillage4ID, rmClassID("natives"));

			if (cNumberNonGaiaPlayers <=2)		   
		    rmPlaceGroupingAtLoc(nativesVillage4ID, 0, 0.775, 0.225);
			else
			rmPlaceGroupingAtLoc(nativesVillage4ID, 0, 0.775, 0.225);
	    }
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/

            if (subCiv4 == rmGetCivID("zen"))
	    {  
		    int nativesVillage5ID = -1;
		    nativesVillageType = rmRandInt(1,3);
			nativesVillage5ID = rmCreateGrouping("natives village 5", "native zen temple cj 0"+nativesVillageType);
			rmSetGroupingMinDistance(nativesVillage5ID, 0.0);
			rmSetGroupingMaxDistance(nativesVillage5ID, 0.0);
			rmAddGroupingToClass(nativesVillage5ID, rmClassID("natives"));
	
			if (cNumberNonGaiaPlayers <=2)		   
		    rmPlaceGroupingAtLoc(nativesVillage5ID, 0, 0.500, 0.800);
			//else
			//rmPlaceGroupingAtLoc(nativesVillage5ID, 0, 0.35, 0.65);
	    }	

/*------------------------------------------------------------------------------------------------------------------------------------------------*/

            if (subCiv5 == rmGetCivID("jesuit"))
	    {  
		    int nativesVillage6ID = -1;
		    nativesVillageType = rmRandInt(1,3);
			nativesVillage6ID = rmCreateGrouping("natives village 6", "native jesuit mission cj 0"+nativesVillageType);
			rmSetGroupingMinDistance(nativesVillage6ID, 0.0);
			rmSetGroupingMaxDistance(nativesVillage6ID, 0.0);
			rmAddGroupingToClass(nativesVillage6ID, rmClassID("natives"));
	
			if (cNumberNonGaiaPlayers <=2)		   
		    rmPlaceGroupingAtLoc(nativesVillage6ID, 0, 0.500, 0.200);
			//else
			//rmPlaceGroupingAtLoc(nativesVillage6ID, 0, 0.65, 0.35);
	    }		
		

/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================================================*/
// ******************************************************** CHECK FOR KOTH GAME MODE: *********************************************************** //
/*================================================================================================================================================*/

        if(rmGetIsKOTH()) 
	{
       
        float xLoc = 0.5;
        float yLoc = 0.5;
        float walk = 0.0;
      
        ypKingsHillPlacer(xLoc, xLoc, walk, 0);
        rmEchoInfo("XLOC = "+xLoc);
        rmEchoInfo("XLOC = "+yLoc);
    }

/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================================================*/
// ******************************************************** CREATE A CENTER AREA: *************************************************************** //
/*================================================================================================================================================*/

        // DEFINE THE CLASS CENTER:
		int ClassCenter=rmDefineClass("center");
		
		// DEFINE THE CLASS CENTER CONSTRAINTS:
		int centerConstraint=rmCreateClassDistanceConstraint("stay away from center", rmClassID("center"), 15.0);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
    
        int centerID=rmCreateArea("center");
        rmSetAreaSize(centerID, 0.0025, 0.0025);
        rmSetAreaLocation(centerID, 0.5, 0.5);
        rmAddAreaToClass(centerID, rmClassID("center"));
		rmSetAreaCoherence(centerID, 1.0);
        //rmSetAreaMix(centerID, "bayou_grass");
		//rmSetAreaMix(centerID, "rockies_snow");
		//rmSetAreaMix(centerID, "rockies_grass");
		
		// Build the areas.
        rmBuildAllAreas();
		
/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================================================*/
// ******************************************************* DEFINE AND PLACE THE FORESTS: ******************************************************** //
/*================================================================================================================================================*/
    
        // DEFINE THE CLASS FOREST:
		int classForest=rmDefineClass("classForest");
		
		// DEFINE THE FOREST EDGE CONSTRAINTS:
		int forestEdgeConstraint=rmCreatePieConstraint("forest edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.475), rmDegreesToRadians(0), rmDegreesToRadians(360));
  		
		// DEFINE THE CLASS FOREST CONSTRAINTS:
		int forestSuperFarConstraint=rmCreateClassDistanceConstraint("super far vs forest", rmClassID("classForest"), 85.0);
		int forestVeryFarConstraint=rmCreateClassDistanceConstraint("very far vs forest", rmClassID("classForest"), 75.0);
		int forestFarConstraint=rmCreateClassDistanceConstraint("far vs forest", rmClassID("classForest"), 65.0);
		int forestMediumConstraint=rmCreateClassDistanceConstraint("medium stuff vs forest", rmClassID("classForest"), 45.0);
		int forestConstraint=rmCreateClassDistanceConstraint("stuff vs forest", rmClassID("classForest"), 25.0);
		int forestCloseConstraint=rmCreateClassDistanceConstraint("close stuff vs forest", rmClassID("classForest"), 15.0);
		int forestVeryCloseConstraint=rmCreateClassDistanceConstraint("very close stuff vs forest", rmClassID("classForest"), 8.0);
        int forestClosestConstraint=rmCreateClassDistanceConstraint("closest stuff vs forest", rmClassID("classForest"), 4.0);
    
/*------------------------------------------------------------------------------------------------------------------------------------------------*/
		
		
		numTries=10*cNumberNonGaiaPlayers;
        int failCount=0;
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/

        for (i=0; <numTries) 
	{   
        int forest=rmCreateArea("forest "+i, bigIslandID);
        rmSetAreaWarnFailure(forest, false);
        rmSetAreaSize(forest, rmAreaTilesToFraction(200), rmAreaTilesToFraction(350));
        rmSetAreaForestType(forest, "Coastal Japan Forest");
        rmSetAreaForestDensity(forest, 0.5);
        rmSetAreaForestClumpiness(forest, 0.2);
        rmSetAreaForestUnderbrush(forest, 0.1);
        rmSetAreaCoherence(forest, 0.4);
        rmAddAreaToClass(forest, rmClassID("classForest")); 
        
		rmAddAreaConstraint(forest, forestMediumConstraint);
        rmAddAreaConstraint(forest, nativesCloseConstraint); 
        rmAddAreaConstraint(forest, avoidWater4);
		rmAddAreaConstraint(forest, avoidAll);
        rmAddAreaConstraint(forest, playerConstraint);
        rmAddAreaConstraint(forest, centerConstraint);
    
        if(rmBuildArea(forest)==false)
     {
        // Stop trying once we fail 7 times in a row.
        failCount++;
        if(failCount==7)
        break;
     }
        else
        failCount=0; 
  } 

/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.725);
/*================================================================================================================================================*/
// ***************************************************** DEFINE AND PLACE THE RANDOM SILVER: **************************************************** //
/*================================================================================================================================================*/
	    
		// DEFINE THE RANDOM SILVER CONSTRAINTS:
		int avoidSuperFarGold=rmCreateTypeDistanceConstraint("super far gold avoid gold", "AbstractMine", 85.0);
        int avoidVeryFarGold=rmCreateTypeDistanceConstraint("very far gold avoid gold", "AbstractMine", 75.0);
        int avoidFarGold=rmCreateTypeDistanceConstraint("far gold avoid gold", "AbstractMine", 65.0);
        int avoidMediumGold=rmCreateTypeDistanceConstraint("medium stuff avoid gold", "AbstractMine", 45.0);
        int avoidGold=rmCreateTypeDistanceConstraint("stuff avoid gold", "AbstractMine", 25.0);
        int avoidCloseGold=rmCreateTypeDistanceConstraint("close stuff avoid gold", "AbstractMine", 15.0);
        int avoidVeryCloseGold=rmCreateTypeDistanceConstraint("very close avoid gold", "AbstractMine", 10.0);
        int avoidClosestGold=rmCreateTypeDistanceConstraint("closest stuff avoid gold", "AbstractMine", 5.0); 		
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
		
		int goldID = rmCreateObjectDef("random silver");
	    rmAddObjectDefItem(goldID, "MineGold", 1, 0);
	    rmSetObjectDefMinDistance(goldID, 0.0);
	    rmSetObjectDefMaxDistance(goldID, rmXFractionToMeters(0.5));
    
		rmAddObjectDefConstraint(goldID, playerCloseConstraint);
        rmAddObjectDefConstraint(goldID, avoidAll);
		rmAddObjectDefConstraint(goldID, avoidWater4);
	    rmAddObjectDefConstraint(goldID, centerConstraint);
        rmAddObjectDefConstraint(goldID, avoidFarGold);
        rmAddObjectDefConstraint(goldID, nativesCloseConstraint);
        rmAddObjectDefConstraint(goldID, forestCloseConstraint);    
	    
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefInArea(goldID, 0, bigIslandID, cNumberNonGaiaPlayers*6.0);
		else
		rmPlaceObjectDefInArea(goldID, 0, bigIslandID, cNumberNonGaiaPlayers*3.0);
		
/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================================================*/  
// ****************************************************** DEFINE AND PLACE THE RANDOM BERRIES: ************************************************** //
/*================================================================================================================================================*/
	
		// DEFINE THE RANDOM BERRIES CONSTRAINTS:
		int avoidSuperFarFruits=rmCreateTypeDistanceConstraint("super far fruits avoid fruits", "AbstractFruit", 85.0);
        int avoidVeryFarFruits=rmCreateTypeDistanceConstraint("very far fruits avoid fruits", "AbstractFruit", 75.0);
        int avoidFarFruits=rmCreateTypeDistanceConstraint("far fruits avoid fruits", "AbstractFruit", 65.0);
        int avoidMediumFruits=rmCreateTypeDistanceConstraint("medium stuff avoid fruits", "AbstractFruit", 45.0);
        int avoidFruits=rmCreateTypeDistanceConstraint("stuff avoid fruits", "AbstractFruit", 25.0);
        int avoidCloseFruits=rmCreateTypeDistanceConstraint("close stuff avoid fruits", "AbstractFruit", 15.0);
        int avoidVeryCloseFruits=rmCreateTypeDistanceConstraint("very close avoid fruits", "AbstractFruit", 10.0);
        int avoidClosestFruits=rmCreateTypeDistanceConstraint("closest stuff avoid fruits", "AbstractFruit", 5.0); 		
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
		
		int berriesID=rmCreateObjectDef("random berries");
	    rmAddObjectDefItem(berriesID, "BerryBush", rmRandInt(4,6), 6.0);  
	    rmSetObjectDefMinDistance(berriesID, 0.0);
	    rmSetObjectDefMaxDistance(berriesID, rmXFractionToMeters(0.5));
    
		rmAddObjectDefConstraint(berriesID, playerCloseConstraint);
	    rmAddObjectDefConstraint(berriesID, avoidAll);
		rmAddObjectDefConstraint(berriesID, avoidWater4);
		rmAddObjectDefConstraint(berriesID, centerConstraint);
	    rmAddObjectDefConstraint(berriesID, avoidFarFruits);
		rmAddObjectDefConstraint(berriesID, avoidCloseGold);
	    rmAddObjectDefConstraint(berriesID, nativesCloseConstraint);
        rmAddObjectDefConstraint(berriesID, forestCloseConstraint);    
	    
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefInArea(berriesID, 0, bigIslandID, cNumberNonGaiaPlayers*6); 
	    else
		rmPlaceObjectDefInArea(berriesID, 0, bigIslandID, cNumberNonGaiaPlayers*3); 
		
/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.775);
/*================================================================================================================================================*/
// ***************************************************** DEFINE AND PLACE THE HUNTABLES 1: ****************************************************** //
/*================================================================================================================================================*/	
	
	    // DEFINE THE RANDOM HUNTABLE 1 CONSTRAINTS:
		int avoidSuperFarHuntable=rmCreateTypeDistanceConstraint("super far stuff avoid huntable", "Huntable", 85.0);
        int avoidVeryFarHuntable=rmCreateTypeDistanceConstraint("very far stuff avoid huntable", "Huntable", 75.0);
        int avoidFarHuntable=rmCreateTypeDistanceConstraint("far stuff avoid huntable", "Huntable", 65.0);
        int avoidMediumHuntable=rmCreateTypeDistanceConstraint("medium stuff avoid huntable", "Huntable", 45.0);
        int avoidHuntable=rmCreateTypeDistanceConstraint("stuff avoid huntable", "Huntable", 25.0);
        int avoidCloseHuntable=rmCreateTypeDistanceConstraint("close stuff avoid huntable", "Huntable", 15.0);
        int avoidVeryCloseHuntable=rmCreateTypeDistanceConstraint("very close avoid huntable", "Huntable", 10.0);
        int avoidClosestHuntable=rmCreateTypeDistanceConstraint("closest stuff avoid huntable", "Huntable", 5.0); 
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
		
		int huntableID=rmCreateObjectDef("random huntable 1");
	    rmAddObjectDefItem(huntableID, "ypSerow", rmRandInt(3,5), 5.0);
	    rmSetObjectDefMinDistance(huntableID, 0.0);
	    rmSetObjectDefMaxDistance(huntableID, rmXFractionToMeters(0.5));
		rmSetObjectDefCreateHerd(huntableID, true);
		
		rmAddObjectDefConstraint(huntableID, avoidFarHuntable);
		rmAddObjectDefConstraint(huntableID, playerCloseConstraint);
	    rmAddObjectDefConstraint(huntableID, avoidAll);
		rmAddObjectDefConstraint(huntableID, avoidWater4);
		rmAddObjectDefConstraint(huntableID, centerConstraint);
	    rmAddObjectDefConstraint(huntableID, avoidCloseFruits);
		rmAddObjectDefConstraint(huntableID, avoidCloseGold);
	    rmAddObjectDefConstraint(huntableID, nativesCloseConstraint);
        rmAddObjectDefConstraint(huntableID, forestCloseConstraint);
    
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefInArea(huntableID, 0, bigIslandID, cNumberNonGaiaPlayers*6);
		else
		rmPlaceObjectDefInArea(huntableID, 0, bigIslandID, cNumberNonGaiaPlayers*3);

/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================================================*/
// ***************************************************** DEFINE AND PLACE THE HUNTABLES 2: ****************************************************** //
/*================================================================================================================================================*/	
	
	    // DEFINE THE RANDOM HUNTABLE 2 CONSTRAINTS:
		int avoidSuperFarHuntable2=rmCreateTypeDistanceConstraint("super far stuff avoid huntable2", "Huntable", 85.0);
        int avoidVeryFarHuntable2=rmCreateTypeDistanceConstraint("very far stuff avoid huntable2", "Huntable", 75.0);
        int avoidFarHuntable2=rmCreateTypeDistanceConstraint("far stuff avoid huntable2", "Huntable", 65.0);
        int avoidMediumHuntable2=rmCreateTypeDistanceConstraint("medium stuff avoid huntable2", "Huntable", 45.0);
        int avoidHuntable2=rmCreateTypeDistanceConstraint("stuff avoid huntable2", "Huntable", 25.0);
        int avoidCloseHuntable2=rmCreateTypeDistanceConstraint("close stuff avoid huntable2", "Huntable", 15.0);
        int avoidVeryCloseHuntable2=rmCreateTypeDistanceConstraint("very close avoid huntable2", "Huntable", 10.0);
        int avoidClosestHuntable2=rmCreateTypeDistanceConstraint("closest stuff avoid huntable2", "Huntable", 5.0); 
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
		
		int huntable2ID=rmCreateObjectDef("random huntable 2");
	    rmAddObjectDefItem(huntable2ID, "ypGiantSalamander", rmRandInt(3,5), 5.0);
	    rmSetObjectDefMinDistance(huntable2ID, 0.0);
	    rmSetObjectDefMaxDistance(huntable2ID, rmXFractionToMeters(0.5));
		rmSetObjectDefCreateHerd(huntable2ID, true);
		
		rmAddObjectDefConstraint(huntable2ID, avoidFarHuntable2);
		rmAddObjectDefConstraint(huntable2ID, avoidMediumHuntable);
		rmAddObjectDefConstraint(huntable2ID, playerCloseConstraint);
	    rmAddObjectDefConstraint(huntable2ID, avoidAll);
		rmAddObjectDefConstraint(huntable2ID, avoidWater4);
		rmAddObjectDefConstraint(huntable2ID, centerConstraint);
	    rmAddObjectDefConstraint(huntable2ID, avoidCloseFruits);
		rmAddObjectDefConstraint(huntable2ID, avoidCloseGold);
	    rmAddObjectDefConstraint(huntable2ID, nativesCloseConstraint);
        rmAddObjectDefConstraint(huntable2ID, forestCloseConstraint);
    
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefInArea(huntable2ID, 0, bigIslandID, cNumberNonGaiaPlayers*6);
		else
		rmPlaceObjectDefInArea(huntable2ID, 0, bigIslandID, cNumberNonGaiaPlayers*3);

/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.825);
/*================================================================================================================================================*/
// *************************************************** DEFINE AND PLACE SOME EASY NUGGETS: ****************************************************** //
/*================================================================================================================================================*/

	    // DEFINE THE NUGGET CONSTRAINTS:
		int avoidSuperFarNugget=rmCreateTypeDistanceConstraint("super far nugget avoid nugget", "AbstractNugget", 85.0);
		int avoidVeryFarNugget=rmCreateTypeDistanceConstraint("very far nugget avoid nugget", "AbstractNugget", 75.0);
		int avoidFarNugget=rmCreateTypeDistanceConstraint("far nugget avoid nugget", "AbstractNugget", 65.0);
		int avoidMediumNugget=rmCreateTypeDistanceConstraint("medium stuff avoid nugget", "AbstractNugget", 45.0);
		int avoidNugget=rmCreateTypeDistanceConstraint("stuff avoid nugget", "AbstractNugget", 25.0);
		int avoidCloseNugget=rmCreateTypeDistanceConstraint("close stuff avoid nugget", "AbstractNugget", 15.0);
		int avoidVeryCloseNugget=rmCreateTypeDistanceConstraint("very close stuff avoid nugget", "AbstractNugget", 10.0);
		int avoidClosestNugget=rmCreateTypeDistanceConstraint("closest stuff avoid nugget", "AbstractNugget", 5.0);
		
		// DEFINE THE NUGGET EDGE CONSTRAINTS:
		int nuggetsEdgeConstraint=rmCreatePieConstraint("nuggets edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.485), rmDegreesToRadians(0), rmDegreesToRadians(360));

/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
		
		int nuggetID1= rmCreateObjectDef("nugget easy"); 
	    rmAddObjectDefItem(nuggetID1, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nuggetID1, 0.0);
	    rmSetObjectDefMaxDistance(nuggetID1, rmXFractionToMeters(0.5));
		rmSetNuggetDifficulty(1, 2);
		
		rmAddObjectDefConstraint(nuggetID1, avoidFarNugget);
		rmAddObjectDefConstraint(nuggetID1, avoidCloseHuntable2);
		rmAddObjectDefConstraint(nuggetID1, avoidCloseHuntable);
		rmAddObjectDefConstraint(nuggetID1, playerCloseConstraint);
	    rmAddObjectDefConstraint(nuggetID1, avoidAll);
		rmAddObjectDefConstraint(nuggetID1, avoidWater4);
		rmAddObjectDefConstraint(nuggetID1, centerConstraint);
	    rmAddObjectDefConstraint(nuggetID1, avoidCloseFruits);
		rmAddObjectDefConstraint(nuggetID1, avoidCloseGold);
	    rmAddObjectDefConstraint(nuggetID1, nativesCloseConstraint);
        rmAddObjectDefConstraint(nuggetID1, forestCloseConstraint);
    
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefInArea(nuggetID1, 0, bigIslandID, cNumberNonGaiaPlayers*6);
        else
		rmPlaceObjectDefInArea(nuggetID1, 0, bigIslandID, cNumberNonGaiaPlayers*3);
		
// **************************************************** DEFINE AND PLACE THE RANDOM TREES: ****************************************************** //
/*================================================================================================================================================*/
    
		// DEFINE THE TREE CONSTRAINTS:
		int avoidSuperFarTrees=rmCreateTypeDistanceConstraint("super far stuff vs trees", "Tree", 85.0);
		int avoidVeryFarTrees=rmCreateTypeDistanceConstraint("very far stuff vs trees", "Tree", 75.0);
		int avoidFarTrees=rmCreateTypeDistanceConstraint("far stuff vs trees", "Tree", 65.0);
		int avoidMediumTrees=rmCreateTypeDistanceConstraint("medium stuff vs trees", "Tree", 45.0);
		int avoidTrees=rmCreateTypeDistanceConstraint("stuff vs trees", "Tree", 25.0);
		int avoidCloseTrees=rmCreateTypeDistanceConstraint("close stuff vs trees", "Tree", 15.0);
		int avoidVeryCloseTrees=rmCreateTypeDistanceConstraint("very close stuff vs trees", "Tree", 8.0);
		int avoidClosestTrees=rmCreateTypeDistanceConstraint("closest stuff vs trees", "Tree", 5.0);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
	
		// THE RANDOM TREES ONE:
		int randomTreeID=rmCreateObjectDef("The Random Tree One"+i);
		//rmAddObjectDefItem(randomTreeID, "TreeAndes", rmRandInt(1,4), 3.0);
		rmAddObjectDefItem(randomTreeID, "ypTreeJapaneseMaple", 1, 0.0);
		rmSetObjectDefMinDistance(randomTreeID, 0.0);
		rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
		
	    rmAddObjectDefConstraint(randomTreeID, avoidClosestAll);
		rmAddObjectDefConstraint(randomTreeID, playerVeryCloseConstraint);
		rmAddObjectDefConstraint(randomTreeID, centerConstraint);
		rmAddObjectDefConstraint(randomTreeID, avoidClosestTrees);
		rmAddObjectDefConstraint(randomTreeID, avoidClosestFruits);
		rmAddObjectDefConstraint(randomTreeID, avoidClosestHuntable);
		rmAddObjectDefConstraint(randomTreeID, avoidClosestHuntable2);
		rmAddObjectDefConstraint(randomTreeID, avoidClosestNugget);
		rmAddObjectDefConstraint(randomTreeID, forestClosestConstraint);
		rmAddObjectDefConstraint(randomTreeID, avoidClosestGold);
		rmAddObjectDefConstraint(randomTreeID, avoidWater4);
		rmAddObjectDefConstraint(randomTreeID, nativesClosestConstraint);
	
        if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefInArea(randomTreeID, 0, bigIslandID, cNumberNonGaiaPlayers*30);
        else
		rmPlaceObjectDefInArea(randomTreeID, 0, bigIslandID, cNumberNonGaiaPlayers*15);

/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================================================*/
// *************************************************** DEFINE AND PLACE THE PLATEAU TREES: ****************************************************** //
/*================================================================================================================================================*/
       
		// DEFINE THE TREES CONSTRAINTS:
		int avoidSuperFarWood=rmCreateTypeDistanceConstraint("super far stuff vs wood", "Wood", 85.0);
		int avoidVeryFarWood=rmCreateTypeDistanceConstraint("very far stuff vs wood", "Wood", 75.0);
		int avoidFarWood=rmCreateTypeDistanceConstraint("far stuff vs wood", "Wood", 65.0);
		int avoidMediumWood=rmCreateTypeDistanceConstraint("medium stuff vs wood", "Wood", 35.0);
		int avoidWood=rmCreateTypeDistanceConstraint("stuff vs wood", "Wood", 20.0);
		int avoidCloseWood=rmCreateTypeDistanceConstraint("close stuff vs wood", "Wood", 15.0);
		int avoidVeryCloseWood=rmCreateTypeDistanceConstraint("very close stuff vs wood", "Wood", 8.0);
		int avoidClosestWood=rmCreateTypeDistanceConstraint("closest stuff vs wood", "Wood", 4.0);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
		
		int woodID = rmCreateObjectDef("The Wood 1");
	    rmAddObjectDefItem(woodID, "ypTreeJapaneseMaple", 1, 0);
	    rmSetObjectDefMinDistance(woodID, 0.0);
	    rmSetObjectDefMaxDistance(woodID, rmXFractionToMeters(0.5));
	
	    rmAddObjectDefConstraint(woodID, avoidCloseWood);
		rmAddObjectDefConstraint(woodID, avoidAll);
		rmAddObjectDefConstraint(woodID, avoidWater4);

		rmPlaceObjectDefInArea(woodID, 0, smallIslandID, 6.0);
		rmPlaceObjectDefInArea(woodID, 0, smallIsland2ID, 6.0);
		rmPlaceObjectDefInArea(woodID, 0, smallIsland3ID, 6.0);
		rmPlaceObjectDefInArea(woodID, 0, smallIsland4ID, 6.0);
	    
/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.875);
/*================================================================================================================================================*/
// ************************************************* DEFINE AND PLACE THE PLATEAU HUNTABLES: **************************************************** //
/*================================================================================================================================================*/
       
		// DEFINE THE HUNTABLES HERDS CONSTRAINTS:
		int avoidSuperFarFood=rmCreateTypeDistanceConstraint("super far stuff vs food", "Resource", 85.0);
		int avoidVeryFarFood=rmCreateTypeDistanceConstraint("very far stuff vs food", "Resource", 75.0);
		int avoidFarFood=rmCreateTypeDistanceConstraint("far stuff vs food", "Resource", 65.0);
		int avoidMediumFood=rmCreateTypeDistanceConstraint("medium stuff vs food", "Resource", 45.0);
		int avoidFood=rmCreateTypeDistanceConstraint("stuff vs food", "Resource", 20.0);
		int avoidCloseFood=rmCreateTypeDistanceConstraint("close stuff vs food", "Resource", 15.0);
		int avoidVeryCloseFood=rmCreateTypeDistanceConstraint("very close stuff vs food", "Resource", 8.0);
		int avoidClosestFood=rmCreateTypeDistanceConstraint("closest stuff vs food", "Resource", 4.0);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
		
		int foodID = rmCreateObjectDef("The Food 1");
	    rmAddObjectDefItem(foodID, "BerryBush", rmRandInt(3,5), 4.0);
	    rmSetObjectDefMinDistance(foodID, 0.0);
	    rmSetObjectDefMaxDistance(foodID, rmXFractionToMeters(0.5));

	    rmAddObjectDefConstraint(foodID, avoidCloseFood);
		rmAddObjectDefConstraint(foodID, avoidClosestWood);
		rmAddObjectDefConstraint(foodID, avoidAll);
        rmAddObjectDefConstraint(foodID, avoidWater4);
	    
		rmPlaceObjectDefInArea(foodID, 0, smallIslandID, 3.0);
		rmPlaceObjectDefInArea(foodID, 0, smallIsland2ID, 3.0);
		rmPlaceObjectDefInArea(foodID, 0, smallIsland3ID, 3.0);
		rmPlaceObjectDefInArea(foodID, 0, smallIsland4ID, 3.0);
  
/*================================================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.90);
/*================================================================================================================================================*/	        
// ******************************************** DEFINE AND PLACE THE SMALL ISLANDS GOLD MINES: ************************************************** //
/*================================================================================================================================================*/
       
		// DEFINE THE GOLD MINE CONSTRAINTS:
		int avoidSuperFarGold2=rmCreateTypeDistanceConstraint("super far stuff vs gold", "Gold", 85.0);
		int avoidVeryFarGold2=rmCreateTypeDistanceConstraint("very far stuff vs gold", "Gold", 75.0);
		int avoidFarGold2=rmCreateTypeDistanceConstraint("far stuff vs gold", "Gold", 65.0);
		int avoidMediumGold2=rmCreateTypeDistanceConstraint("medium stuff vs gold", "Gold", 45.0);
		int avoidGold2=rmCreateTypeDistanceConstraint("stuff vs gold", "Gold", 20.0);
		int avoidCloseGold2=rmCreateTypeDistanceConstraint("close stuff vs gold", "Gold", 15.0);
		int avoidVeryCloseGold2=rmCreateTypeDistanceConstraint("very close stuff vs gold", "Gold", 8.0);
		int avoidClosestGold2=rmCreateTypeDistanceConstraint("closest stuff vs gold", "Gold", 4.0);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
		
		int gold2ID = rmCreateObjectDef("The Gold Mines 2");
	    rmAddObjectDefItem(gold2ID, "minegold", 1, 0);
	    rmSetObjectDefMinDistance(gold2ID, 0.0);
	    rmSetObjectDefMaxDistance(gold2ID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(gold2ID, avoidCloseGold2);
		rmAddObjectDefConstraint(gold2ID, avoidVeryCloseFood);
		rmAddObjectDefConstraint(gold2ID, avoidClosestWood);
		rmAddObjectDefConstraint(gold2ID, avoidAll);
        rmAddObjectDefConstraint(gold2ID, avoidWater4);
    
		rmPlaceObjectDefInArea(gold2ID, 0, smallIslandID, 3.0);
		rmPlaceObjectDefInArea(gold2ID, 0, smallIsland2ID, 3.0);
		rmPlaceObjectDefInArea(gold2ID, 0, smallIsland3ID, 3.0);
		rmPlaceObjectDefInArea(gold2ID, 0, smallIsland4ID, 3.0);
  
/*================================================================================================================================================*/
  // TEXT:
  // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
  rmSetStatusText("",0.925);
/*================================================================================================================================================*/
// ************************************************* DEFINE AND PLACE THE PLATEAU TREASURES: **************************************************** //
/*================================================================================================================================================*/
       
		// DEFINE THE TREASURES CONSTRAINTS:
		int avoidSuperFarTreasures=rmCreateTypeDistanceConstraint("super far stuff vs treasures", "AbstractNugget", 85.0);
		int avoidVeryFarTreasures=rmCreateTypeDistanceConstraint("very far stuff vs treasures", "AbstractNugget", 75.0);
		int avoidFarTreasures=rmCreateTypeDistanceConstraint("far stuff vs treasures", "AbstractNugget", 65.0);
		int avoidMediumTreasures=rmCreateTypeDistanceConstraint("medium stuff vs treasures", "AbstractNugget", 45.0);
		int avoidTreasures=rmCreateTypeDistanceConstraint("stuff vs treasures", "AbstractNugget", 30.0);
		int avoidCloseTreasures=rmCreateTypeDistanceConstraint("close stuff vs treasures", "AbstractNugget", 15.0);
		int avoidVeryCloseTreasures=rmCreateTypeDistanceConstraint("very close stuff vs treasures", "AbstractNugget", 8.0);
		int avoidClosestTreasures=rmCreateTypeDistanceConstraint("closest stuff vs treasures", "AbstractNugget", 4.0);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
		
		int treasuresID = rmCreateObjectDef("The Treasures 1");
	    rmAddObjectDefItem(treasuresID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(treasuresID, 0.0);
	    rmSetObjectDefMaxDistance(treasuresID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(treasuresID, avoidCloseTreasures);
		rmAddObjectDefConstraint(treasuresID, avoidVeryCloseGold2);
		rmAddObjectDefConstraint(treasuresID, avoidVeryCloseFood);
		rmAddObjectDefConstraint(treasuresID, avoidClosestWood);
		rmAddObjectDefConstraint(treasuresID, avoidAll);
        rmAddObjectDefConstraint(treasuresID, avoidWater4);
    
		rmPlaceObjectDefInArea(treasuresID, 0, smallIslandID, 3.0);
		rmPlaceObjectDefInArea(treasuresID, 0, smallIsland2ID, 3.0);
		rmPlaceObjectDefInArea(treasuresID, 0, smallIsland3ID, 3.0);
		rmPlaceObjectDefInArea(treasuresID, 0, smallIsland4ID, 3.0);

/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================================================*/
// ********************************************************* DEFINE AND PLACE SOME PATCH: ******************************************************* //
/*================================================================================================================================================*/
        
		// DEFINE THE CLASS PATCH:
		int classPatch=rmDefineClass("classPatch");
		
		// DEFINE THE CLASS PATCH CONSTRAINTS:
		int patchConstraint=rmCreateClassDistanceConstraint("patch vs. patch", rmClassID("classPatch"), 5.0);
        
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
		
		for (i=0; < 30) 
	{
        int patchID=rmCreateArea("first patch "+i);
        rmSetAreaWarnFailure(patchID, false);
        rmSetAreaSize(patchID, rmAreaTilesToFraction(100), rmAreaTilesToFraction(200));
        rmSetAreaMix(patchID, "coastal_japan_b");
        rmSetAreaTerrainType(patchID, "coastal_japan\ground_grass3_co_japan");
        rmAddAreaTerrainLayer(patchID, "coastal_japan\ground_grass2_co_japan", 0, 1);
        rmAddAreaToClass(patchID, rmClassID("classPatch"));
        rmSetAreaCoherence(patchID, 0.4);
        
		rmAddAreaConstraint(patchID, avoidWater4);
		rmAddAreaConstraint(patchID, playerCloseConstraint);
        
		rmBuildArea(patchID); 
    }
	
/*------------------------------------------------------------------------------------------------------------------------------------------------*/

        for (i=0; <10) 
	{
        int dirtPatchID=rmCreateArea("paint patch "+i);
        rmSetAreaWarnFailure(dirtPatchID, false);
        rmSetAreaSize(dirtPatchID, rmAreaTilesToFraction(200), rmAreaTilesToFraction(300));
        rmSetAreaMix(dirtPatchID, "coastal_japan_b");
        rmSetAreaTerrainType(dirtPatchID, "coastal_japan\ground_grass3_co_japan");
        rmAddAreaTerrainLayer(dirtPatchID, "coastal_japan\ground_grass1_co_japan", 0, 1);
        rmAddAreaToClass(dirtPatchID, rmClassID("classPatch"));
        rmSetAreaCoherence(dirtPatchID, 0.4);
        
		rmAddAreaConstraint(dirtPatchID, avoidWater4);
		rmAddAreaConstraint(dirtPatchID, playerCloseConstraint);
        rmAddAreaConstraint(dirtPatchID, patchConstraint);
        
		rmBuildArea(dirtPatchID); 
    }
	
/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.975);
/*================================================================================================================================================*/
// *************************************************** DEFINE AND PLACE SOME RANDOM WHALES: ***************************************************** //
/*================================================================================================================================================*/

	    // DEFINE THE WHALE CONSTRAINTS:
		int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "AbstractWhale", 65.0);	
	    int fishVsWhaleID=rmCreateTypeDistanceConstraint("fish v whale", "AbstractWhale", 20.0); 
		int nuggetsVsWhaleID=rmCreateTypeDistanceConstraint("nuggets v whale", "AbstractWhale", 20.0); 
	    int whaleLand = rmCreateTerrainDistanceConstraint("whale land", "land", true, 20.0);
        int whaleEdgeConstraint = rmCreatePieConstraint("whale away from edge of map", 0.5, 0.5, 0, rmGetMapXSize()-18, 0, 0, 0);
		
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
		
		int whaleID=rmCreateObjectDef("whale");
	    rmAddObjectDefItem(whaleID, "HumpbackWhale", 1, 0.0);
	    rmSetObjectDefMinDistance(whaleID, 0.0);
	    rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));		//Distance whales will be placed from the starting spot (below)
	    
		rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
	    rmAddObjectDefConstraint(whaleID, whaleLand);
        rmAddObjectDefConstraint(whaleID, whaleEdgeConstraint);
	    
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*6.0 + rmRandInt(2,3));
		else
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3.0 + rmRandInt(2,3));
		
/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.985);
/*================================================================================================================================================*/
// ************************************* PLACE RANDOM FISH EVERYWHERE, BUT RESTRAINED TO AVOID WHALES: ****************************************** //
/*================================================================================================================================================*/

	    // DEFINE THE FISH CONSTRAINTS:
		int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "AbstractFish", 25.0);		
	    int fishVsFishTarponID=rmCreateTypeDistanceConstraint("fish v fish2", "AbstractFish", 20.0);
	    int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 8.0);			
	    int avoidLand = rmCreateTerrainDistanceConstraint("ship avoid land", "land", true, 15.0);
		
		// DEFINE THE FISH EDGE CONSTRAINTS:
		int fishEdgeConstraint=rmCreatePieConstraint("fish edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.485), rmDegreesToRadians(0), rmDegreesToRadians(360));

	
/*------------------------------------------------------------------------------------------------------------------------------------------------*/	
	
	    int fishID=rmCreateObjectDef("fish 1");
	    rmAddObjectDefItem(fishID, "ypFishCatfish", 1, 0.0);
	    rmSetObjectDefMinDistance(fishID, 0.0);
	    rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(fishID, fishVsFishID);
	    rmAddObjectDefConstraint(fishID, fishVsWhaleID);
	    rmAddObjectDefConstraint(fishID, fishLand);
		rmAddObjectDefConstraint(fishID, fishEdgeConstraint);
	    
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 20*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 10*cNumberNonGaiaPlayers);
	
/*------------------------------------------------------------------------------------------------------------------------------------------------*/	

	    int fish2ID=rmCreateObjectDef("fish 2");
	    rmAddObjectDefItem(fish2ID, "ypSquid", 1, 0.0);
	    rmSetObjectDefMinDistance(fish2ID, 0.0);
	    rmSetObjectDefMaxDistance(fish2ID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(fish2ID, fishVsFishTarponID);
	    rmAddObjectDefConstraint(fish2ID, fishVsWhaleID);
	    rmAddObjectDefConstraint(fish2ID, fishLand);
		rmAddObjectDefConstraint(fish2ID, fishEdgeConstraint);
	    
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefAtLoc(fish2ID, 0, 0.5, 0.5, 20*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(fish2ID, 0, 0.5, 0.5, 10*cNumberNonGaiaPlayers);

/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.995);
/*================================================================================================================================================*/
// *************************************************** DEFINE AND PLACE THE WATER NUGGETS: ****************************************************** //
/*================================================================================================================================================*/
  
        int nugget2= rmCreateObjectDef("nugget water"); 
        rmAddObjectDefItem(nugget2, "ypNuggetBoat", 1, 0.0);
        rmSetNuggetDifficulty(5, 5);
        rmSetObjectDefMinDistance(nugget2, rmXFractionToMeters(0.0));
        rmSetObjectDefMaxDistance(nugget2, rmXFractionToMeters(0.5));
        
		rmAddObjectDefConstraint(nugget2, avoidLand);
        rmAddObjectDefConstraint(nugget2, avoidFarNugget);
		rmAddObjectDefConstraint(nugget2, nuggetsEdgeConstraint);
		rmAddObjectDefConstraint(nugget2, nuggetsVsWhaleID);
        
		if (cNumberNonGaiaPlayers <=2)
		rmPlaceObjectDefAtLoc(nugget2, 0, 0.5, 0.5, cNumberNonGaiaPlayers*8);
        else
        rmPlaceObjectDefAtLoc(nugget2, 0, 0.5, 0.5, cNumberNonGaiaPlayers*4);		
  
/*================================================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================================================*/
}
/*================================================================================================================================================*/
// ******************************************************** THIS IS THE END OF THE MAP: ********************************************************* //
/*================================================================================================================================================*/
